Package com.google.protobuf

# Class Type

java.lang.Object
com.google.protobuf.AbstractMessageLite
com.google.protobuf.AbstractMessage
com.google.protobuf.GeneratedMessage
com.google.protobuf.Type

All Implemented Interfaces:
  `Message`, `MessageLite`, `MessageLiteOrBuilder`, `MessageOrBuilder`, `TypeOrBuilder`, `Serializable`

public final class Type extends GeneratedMessage implements TypeOrBuilder
Protobuf type `google.protobuf.Type`

See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static final class`
`Type.Builder`
Protobuf type `google.protobuf.Type`

## Nested classes/interfaces inherited from class com.google.protobuf.GeneratedMessage

`GeneratedMessage.ExtendableBuilder<MessageT extends GeneratedMessage.ExtendableMessage<MessageT>,BuilderT extends GeneratedMessage.ExtendableBuilder<MessageT,BuilderT>>, GeneratedMessage.ExtendableMessage<MessageT extends GeneratedMessage.ExtendableMessage<MessageT>>, GeneratedMessage.ExtendableMessageOrBuilder<MessageT extends GeneratedMessage.ExtendableMessage<MessageT>>, GeneratedMessage.FieldAccessorTable, GeneratedMessage.GeneratedExtension<ContainingT extends Message,T>, GeneratedMessage.UnusedPrivateParameter`

## Nested classes/interfaces inherited from class com.google.protobuf.AbstractMessage

`AbstractMessage.BuilderParent`

## Nested classes/interfaces inherited from class com.google.protobuf.AbstractMessageLite

`AbstractMessageLite.InternalOneOfEnum`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`EDITION_FIELD_NUMBER`
`static final int`
`FIELDS_FIELD_NUMBER`
`static final int`
`NAME_FIELD_NUMBER`
`static final int`
`ONEOFS_FIELD_NUMBER`
`static final int`
`OPTIONS_FIELD_NUMBER`
`static final int`
`SOURCE_CONTEXT_FIELD_NUMBER`
`static final int`
`SYNTAX_FIELD_NUMBER`

### Fields inherited from class com.google.protobuf.GeneratedMessage

`alwaysUseFieldBuilders, unknownFields`

### Fields inherited from class com.google.protobuf.AbstractMessage

`memoizedSize`

### Fields inherited from class com.google.protobuf.AbstractMessageLite

`memoizedHashCode`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`equals(Object obj)`
Compares the specified object with this message for equality.
`static Type`
`getDefaultInstance()`
`Type`
`getDefaultInstanceForType()`
Get an instance of the type with no fields set.
`static final Descriptors.Descriptor`
`getDescriptor()`
`String`
`getEdition()`
`string edition = 7 [json_name = "edition"];`
`ByteString`
`getEditionBytes()`
`string edition = 7 [json_name = "edition"];`
`Field`
`getFields(int index)`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`int`
`getFieldsCount()`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`List<Field>`
`getFieldsList()`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`FieldOrBuilder`
`getFieldsOrBuilder(int index)`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`List<? extends FieldOrBuilder>`
`getFieldsOrBuilderList()`
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`
`String`
`getName()`
`string name = 1 [json_name = "name"];`
`ByteString`
`getNameBytes()`
`string name = 1 [json_name = "name"];`
`String`
`getOneofs(int index)`
`repeated string oneofs = 3 [json_name = "oneofs"];`
`ByteString`
`getOneofsBytes(int index)`
`repeated string oneofs = 3 [json_name = "oneofs"];`
`int`
`getOneofsCount()`
`repeated string oneofs = 3 [json_name = "oneofs"];`
`ProtocolStringList`
`getOneofsList()`
`repeated string oneofs = 3 [json_name = "oneofs"];`
`Option`
`getOptions(int index)`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`int`
`getOptionsCount()`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`List<Option>`
`getOptionsList()`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`OptionOrBuilder`
`getOptionsOrBuilder(int index)`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`List<? extends OptionOrBuilder>`
`getOptionsOrBuilderList()`
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`
`Parser<Type>`
`getParserForType()`
TODO: Remove this unnecessary intermediate implementation of this method.
`int`
`getSerializedSize()`
Get the number of bytes required to encode this message.
`SourceContext`
`getSourceContext()`
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`
`SourceContextOrBuilder`
`getSourceContextOrBuilder()`
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`
`Syntax`
`getSyntax()`
`.google.protobuf.Syntax syntax = 6 [json_name = "syntax"];`
`int`
`getSyntaxValue()`
`.google.protobuf.Syntax syntax = 6 [json_name = "syntax"];`
`int`
`hashCode()`
Returns the hash code value for this message.
`boolean`
`hasSourceContext()`
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`
`protected GeneratedMessage.FieldAccessorTable`
`internalGetFieldAccessorTable()`
Get the FieldAccessorTable for this type.
`final boolean`
`isInitialized()`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.
`static Type.Builder`
`newBuilder()`
`static Type.Builder`
`newBuilder(Type prototype)`
`Type.Builder`
`newBuilderForType()`
Constructs a new builder for a message of the same type as this message.
`protected Type.Builder`
`newBuilderForType(AbstractMessage.BuilderParent parent)`
Create a nested builder.
`static Type`
`parseDelimitedFrom(InputStream input)`
`static Type`
`parseDelimitedFrom(InputStream input, ExtensionRegistryLite extensionRegistry)`
`static Type`
`parseFrom(byte[] data)`
`static Type`
`parseFrom(byte[] data, ExtensionRegistryLite extensionRegistry)`
`static Type`
`parseFrom(ByteString data)`
`static Type`
`parseFrom(ByteString data, ExtensionRegistryLite extensionRegistry)`
`static Type`
`parseFrom(CodedInputStream input)`
`static Type`
`parseFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry)`
`static Type`
`parseFrom(InputStream input)`
`static Type`
`parseFrom(InputStream input, ExtensionRegistryLite extensionRegistry)`
`static Type`
`parseFrom(ByteBuffer data)`
`static Type`
`parseFrom(ByteBuffer data, ExtensionRegistryLite extensionRegistry)`
`static Parser<Type>`
`parser()`
`Type.Builder`
`toBuilder()`
Constructs a builder initialized with the current message.
`void`
`writeTo(CodedOutputStream output)`
Serializes the message and writes it to `output`.

### Methods inherited from class com.google.protobuf.GeneratedMessage

`canUseUnsafe, computeStringSize, computeStringSizeNoTag, emptyBooleanList, emptyDoubleList, emptyFloatList, emptyIntList, emptyList, emptyLongList, getAllFields, getDescriptorForType, getField, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, getUnknownFields, hasField, hasOneof, internalGetMapField, internalGetMapFieldReflection, isStringEmpty, makeMutableCopy, makeMutableCopy, mergeFromAndMakeImmutableInternal, newFileScopedGeneratedExtension, newInstance, newMessageScopedGeneratedExtension, parseDelimitedWithIOException, parseDelimitedWithIOException, parseUnknownField, parseUnknownFieldProto3, parseWithIOException, parseWithIOException, parseWithIOException, parseWithIOException, serializeBooleanMapTo, serializeIntegerMapTo, serializeLongMapTo, serializeStringMapTo, writeReplace, writeString, writeStringNoTag`

### Methods inherited from class com.google.protobuf.AbstractMessage

`findInitializationErrors, getInitializationErrorString, hashFields, toString`

### Methods inherited from class com.google.protobuf.AbstractMessageLite

`addAll, checkByteStringIsUtf8, toByteArray, toByteString, writeDelimitedTo, writeTo`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface com.google.protobuf.MessageLite

`toByteArray, toByteString, writeDelimitedTo, writeTo`

### Methods inherited from interface com.google.protobuf.MessageOrBuilder

`findInitializationErrors, getAllFields, getDescriptorForType, getField, getInitializationErrorString, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, getUnknownFields, hasField, hasOneof`

## Field Details

### NAME_FIELD_NUMBER

public static final int NAME_FIELD_NUMBER

See Also:
  - Constant Field Values

### FIELDS_FIELD_NUMBER

public static final int FIELDS_FIELD_NUMBER

See Also:
  - Constant Field Values

### ONEOFS_FIELD_NUMBER

public static final int ONEOFS_FIELD_NUMBER

See Also:
  - Constant Field Values

### OPTIONS_FIELD_NUMBER

public static final int OPTIONS_FIELD_NUMBER

See Also:
  - Constant Field Values

### SOURCE_CONTEXT_FIELD_NUMBER

public static final int SOURCE_CONTEXT_FIELD_NUMBER

See Also:
  - Constant Field Values

### SYNTAX_FIELD_NUMBER

public static final int SYNTAX_FIELD_NUMBER

See Also:
  - Constant Field Values

### EDITION_FIELD_NUMBER

public static final int EDITION_FIELD_NUMBER

See Also:
  - Constant Field Values

## Method Details

### getDescriptor

public static final Descriptors.Descriptor getDescriptor()

### internalGetFieldAccessorTable

protected GeneratedMessage.FieldAccessorTable internalGetFieldAccessorTable()
Description copied from class: `GeneratedMessage`
Get the FieldAccessorTable for this type. We can't have the message class pass this in to the constructor because of bootstrapping trouble with DescriptorProtos.

Specified by:
  `internalGetFieldAccessorTable` in class `GeneratedMessage`

### getName

public String getName()
`string name = 1 [json_name = "name"];`

Specified by:
  `getName` in interface `TypeOrBuilder`
Returns:
  The name.

### getNameBytes

public ByteString getNameBytes()
`string name = 1 [json_name = "name"];`

Specified by:
  `getNameBytes` in interface `TypeOrBuilder`
Returns:
  The bytes for name.

### getFieldsList

public List<Field> getFieldsList()
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

Specified by:
  `getFieldsList` in interface `TypeOrBuilder`

### getFieldsOrBuilderList

public List<? extends FieldOrBuilder> getFieldsOrBuilderList()
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

Specified by:
  `getFieldsOrBuilderList` in interface `TypeOrBuilder`

### getFieldsCount

public int getFieldsCount()
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

Specified by:
  `getFieldsCount` in interface `TypeOrBuilder`

### getFields

public Field getFields(int index)
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

Specified by:
  `getFields` in interface `TypeOrBuilder`

### getFieldsOrBuilder

public FieldOrBuilder getFieldsOrBuilder(int index)
`repeated .google.protobuf.Field fields = 2 [json_name = "fields"];`

Specified by:
  `getFieldsOrBuilder` in interface `TypeOrBuilder`

### getOneofsList

public ProtocolStringList getOneofsList()
`repeated string oneofs = 3 [json_name = "oneofs"];`

Specified by:
  `getOneofsList` in interface `TypeOrBuilder`
Returns:
  A list containing the oneofs.

### getOneofsCount

public int getOneofsCount()
`repeated string oneofs = 3 [json_name = "oneofs"];`

Specified by:
  `getOneofsCount` in interface `TypeOrBuilder`
Returns:
  The count of oneofs.

### getOneofs

public String getOneofs(int index)
`repeated string oneofs = 3 [json_name = "oneofs"];`

Specified by:
  `getOneofs` in interface `TypeOrBuilder`
Parameters:
  `index` - The index of the element to return.
Returns:
  The oneofs at the given index.

### getOneofsBytes

public ByteString getOneofsBytes(int index)
`repeated string oneofs = 3 [json_name = "oneofs"];`

Specified by:
  `getOneofsBytes` in interface `TypeOrBuilder`
Parameters:
  `index` - The index of the value to return.
Returns:
  The bytes of the oneofs at the given index.

### getOptionsList

public List<Option> getOptionsList()
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

Specified by:
  `getOptionsList` in interface `TypeOrBuilder`

### getOptionsOrBuilderList

public List<? extends OptionOrBuilder> getOptionsOrBuilderList()
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

Specified by:
  `getOptionsOrBuilderList` in interface `TypeOrBuilder`

### getOptionsCount

public int getOptionsCount()
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

Specified by:
  `getOptionsCount` in interface `TypeOrBuilder`

### getOptions

public Option getOptions(int index)
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

Specified by:
  `getOptions` in interface `TypeOrBuilder`

### getOptionsOrBuilder

public OptionOrBuilder getOptionsOrBuilder(int index)
`repeated .google.protobuf.Option options = 4 [json_name = "options"];`

Specified by:
  `getOptionsOrBuilder` in interface `TypeOrBuilder`

### hasSourceContext

public boolean hasSourceContext()
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`

Specified by:
  `hasSourceContext` in interface `TypeOrBuilder`
Returns:
  Whether the sourceContext field is set.

### getSourceContext

public SourceContext getSourceContext()
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`

Specified by:
  `getSourceContext` in interface `TypeOrBuilder`
Returns:
  The sourceContext.

### getSourceContextOrBuilder

public SourceContextOrBuilder getSourceContextOrBuilder()
`.google.protobuf.SourceContext source_context = 5 [json_name = "sourceContext"];`

Specified by:
  `getSourceContextOrBuilder` in interface `TypeOrBuilder`

### getSyntaxValue

public int getSyntaxValue()
`.google.protobuf.Syntax syntax = 6 [json_name = "syntax"];`

Specified by:
  `getSyntaxValue` in interface `TypeOrBuilder`
Returns:
  The enum numeric value on the wire for syntax.

### getSyntax

public Syntax getSyntax()
`.google.protobuf.Syntax syntax = 6 [json_name = "syntax"];`

Specified by:
  `getSyntax` in interface `TypeOrBuilder`
Returns:
  The syntax.

### getEdition

public String getEdition()
`string edition = 7 [json_name = "edition"];`

Specified by:
  `getEdition` in interface `TypeOrBuilder`
Returns:
  The edition.

### getEditionBytes

public ByteString getEditionBytes()
`string edition = 7 [json_name = "edition"];`

Specified by:
  `getEditionBytes` in interface `TypeOrBuilder`
Returns:
  The bytes for edition.

### isInitialized

public final boolean isInitialized()
Description copied from interface: `MessageLiteOrBuilder`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.

See also: `MessageOrBuilder.getInitializationErrorString()`

Specified by:
  `isInitialized` in interface `MessageLiteOrBuilder`
Overrides:
  `isInitialized` in class `GeneratedMessage`

### writeTo

public void writeTo(CodedOutputStream output) throws IOException
Description copied from interface: `MessageLite`
Serializes the message and writes it to `output`. This does not flush or close the stream.

Specified by:
  `writeTo` in interface `MessageLite`
Overrides:
  `writeTo` in class `GeneratedMessage`
Throws:
  `IOException`

### getSerializedSize

public int getSerializedSize()
Description copied from interface: `MessageLite`
Get the number of bytes required to encode this message. The result is only computed on the first call and memoized after that. If this message requires more than Integer.MAX_VALUE bytes to encode, the return value will be smaller than the actual number of bytes required and might be negative.

Specified by:
  `getSerializedSize` in interface `MessageLite`
Overrides:
  `getSerializedSize` in class `GeneratedMessage`

### equals

public boolean equals(Object obj)
Description copied from interface: `Message`
Compares the specified object with this message for equality. Returns `true` if the given object is a message of the same type (as defined by `getDescriptorForType()`) and has identical values for all of its fields. Subclasses must implement this; inheriting `Object.equals()` is incorrect.

Specified by:
  `equals` in interface `Message`
Overrides:
  `equals` in class `AbstractMessage`
Parameters:
  `obj` - object to be compared for equality with this message
Returns:
  `true` if the specified object is equal to this message

### hashCode

public int hashCode()
Description copied from interface: `Message`
Returns the hash code value for this message. The hash code of a message should mix the message's type (object identity of the descriptor) with its contents (known and unknown field values). Subclasses must implement this; inheriting `Object.hashCode()` is incorrect.

Specified by:
  `hashCode` in interface `Message`
Overrides:
  `hashCode` in class `AbstractMessage`
Returns:
  the hash code value for this message
See Also:
  - `Map.hashCode()`

### parseFrom

public static Type parseFrom(ByteBuffer data) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static Type parseFrom(ByteBuffer data, ExtensionRegistryLite extensionRegistry) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static Type parseFrom(ByteString data) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static Type parseFrom(ByteString data, ExtensionRegistryLite extensionRegistry) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static Type parseFrom(byte[] data) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static Type parseFrom(byte[] data, ExtensionRegistryLite extensionRegistry) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static Type parseFrom(InputStream input) throws IOException

Throws:
  `IOException`

### parseFrom

public static Type parseFrom(InputStream input, ExtensionRegistryLite extensionRegistry) throws IOException

Throws:
  `IOException`

### parseDelimitedFrom

public static Type parseDelimitedFrom(InputStream input) throws IOException

Throws:
  `IOException`

### parseDelimitedFrom

public static Type parseDelimitedFrom(InputStream input, ExtensionRegistryLite extensionRegistry) throws IOException

Throws:
  `IOException`

### parseFrom

public static Type parseFrom(CodedInputStream input) throws IOException

Throws:
  `IOException`

### parseFrom

public static Type parseFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry) throws IOException

Throws:
  `IOException`

### newBuilderForType

public Type.Builder newBuilderForType()
Description copied from interface: `MessageLite`
Constructs a new builder for a message of the same type as this message.

Specified by:
  `newBuilderForType` in interface `Message`
Specified by:
  `newBuilderForType` in interface `MessageLite`

### newBuilder

public static Type.Builder newBuilder()

### newBuilder

public static Type.Builder newBuilder(Type prototype)

### toBuilder

public Type.Builder toBuilder()
Description copied from interface: `MessageLite`
Constructs a builder initialized with the current message. Use this to derive a new message from the current one.

Specified by:
  `toBuilder` in interface `Message`
Specified by:
  `toBuilder` in interface `MessageLite`

### newBuilderForType

protected Type.Builder newBuilderForType(AbstractMessage.BuilderParent parent)
Description copied from class: `AbstractMessage`
Create a nested builder.

Overrides:
  `newBuilderForType` in class `AbstractMessage`

### getDefaultInstance

public static Type getDefaultInstance()

### parser

public static Parser<Type> parser()

### getParserForType

public Parser<Type> getParserForType()
Description copied from class: `GeneratedMessage`
TODO: Remove this unnecessary intermediate implementation of this method.

Specified by:
  `getParserForType` in interface `Message`
Specified by:
  `getParserForType` in interface `MessageLite`
Overrides:
  `getParserForType` in class `GeneratedMessage`

### getDefaultInstanceForType

public Type getDefaultInstanceForType()
Description copied from interface: `MessageLiteOrBuilder`
Get an instance of the type with no fields set. Because no fields are set, all getters for singular fields will return default values and repeated fields will appear empty. This may or may not be a singleton. This differs from the `getDefaultInstance()` method of generated message classes in that this method is an abstract method of the `MessageLite` interface whereas `getDefaultInstance()` is a static method of a specific class. They return the same thing.

Specified by:
  `getDefaultInstanceForType` in interface `MessageLiteOrBuilder`
Specified by:
  `getDefaultInstanceForType` in interface `MessageOrBuilder`